<template>
  <MultiSelect
    :model-value="selectedOption"
    :options="selectableOptions"
    label="name"
    track-by="name"
    :placeholder="t('selectPlaceholder')"
    :required="required"
    :disabled="disabledMode || locked"
    select-label=""
    selected-label=""
    deselect-label=""
    @update:model-value="updateMetadataValue"
  />
</template>

<script lang="ts">
import i18n from '@/plugins/i18n';

import MultiSelect from '@/plugins/vue-multiselect';

import type { ObjectLabel } from '@/types/labels';
import type { Literal, Quad_Object } from '@rdfjs/types';
import factory from 'rdf-ext';

export default defineComponent({
  name: 'InputCombobox',
  components: {
    MultiSelect,
  },
  props: {
    locked: {
      default: false,
      type: Boolean,
    },
    required: {
      default: false,
      type: Boolean,
    },
    entry: {
      required: true,
      type: Object as PropType<Quad_Object>,
    },
    disabledMode: {
      default: false,
      type: Boolean,
    },
    languageCode: {
      default: 'en',
      type: String,
    },
    list: {
      required: true,
      type: Array as PropType<Array<Quad_Object>>,
    },
    listLabels: {
      required: true,
      type: Array as PropType<Array<Array<Quad_Object>>>,
    },
  },
  setup() {
    return { locale: i18n.global.locale, t: i18n.global.t };
  },
  data() {
    return {
      object: null as Quad_Object | null,
    };
  },
  computed: {
    selectableOptions(): ObjectLabel[] {
      return this.list
        .map((entry, index) => {
          let name = entry.value;
          const entryLabels = this.listLabels[index];
          if (entryLabels && entryLabels.length > 0) {
            const currentLanguageLabel = entryLabels.find(
              (label) => (label as Literal).language === this.languageCode,
            );
            const enLanguageLabel = entryLabels.find(
              (label) => (label as Literal).language === 'en',
            );
            if (currentLanguageLabel) {
              name = currentLanguageLabel.value;
            } else if (enLanguageLabel) {
              name = enLanguageLabel.value;
            } else {
              name = entryLabels[0].value;
            }
          }
          return {
            name: name,
            value: entry,
          };
        })
        .sort((item1, item2) => item1.name.localeCompare(item2.name));
    },
    selectedIndex(): number | undefined {
      if (this.object && this.object.value !== '') {
        const index = this.selectableOptions.findIndex(
          (option) => option.value?.value === this.object?.value,
        );
        if (index !== -1) {
          return index;
        }
      }
      return undefined;
    },
    selectedOption(): ObjectLabel | undefined {
      if (this.selectedIndex !== undefined) {
        return this.selectableOptions[this.selectedIndex];
      }
      return undefined;
    },
  },
  watch: {
    entry() {
      this.loadData();
    },
  },
  mounted() {
    if (this.languageCode === 'en' || this.languageCode === 'de') {
      this.locale = this.languageCode;
    } else {
      this.locale = 'en';
    }
    this.loadData();
  },
  methods: {
    updateMetadataValue(label: ObjectLabel | null) {
      if (label?.value) {
        this.object = label.value;
      } else {
        this.object = factory.literal('');
      }
      this.$emit('update:metadata-value', this.object);
    },
    loadData() {
      if (this.object?.value !== this.entry.value) {
        this.object = this.entry;
      }
    },
  },
});
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>
